/* 
 * seta43
 * Juan Galaz
 * http: / / seta43.duckdns.org
 * http: / / seta43.blogspot.com 
 * 2024
 * si5351_c
 * Arduino 1.8.19
 * Basada en: 10kHz to 120MHz VFO by CesarSound - ver 1.0 - Dec/2020.
*/

//#define DEBUG 1
char TITULO[]="--  SI5351  --";
//___________OLED_________
#include "olex.h"
#include  <Wire.h>                 //IDE Standard

#include <Adafruit_SI5351.h>

Adafruit_SI5351 clockgen = Adafruit_SI5351();


//__________ENCODER_______seta43_____
#define PIN_IN1 2
#define PIN_IN2 3
#define EBOTON 4
int D_encoder=0;
char D_e1=0,D_e2=2;

char mandoRotary(void)  // 1-IZQ  2-DER  3-BOTON
{
  
   if (LOW==digitalRead(EBOTON))   { delay(300); return(3);}
   if (D_e1==0) 
      {  if(HIGH==digitalRead(PIN_IN1)) { D_e1=1; if(D_e2==3) { D_encoder++; return(2);} }   }
      else
      {  if(LOW==digitalRead(PIN_IN1))  { D_e1=0; if(D_e2==2) { D_encoder++; return(2);} }   }
      
  if (D_e2==2) 
      {  if(HIGH==digitalRead(PIN_IN2)) { D_e2=3; if(D_e1==1) { D_encoder--; return(1);} }   }
      else
      {  if(LOW==digitalRead(PIN_IN2))  { D_e2=2; if(D_e1==0) { D_encoder--; return(1);} }   }
  return(0);
}
//_________________________________________


float divisor;
char modo=0;
char cambio=1;

long Dato1=35;
long Dato2=1;
long Dato3=1;


void setup(void)
{
  Serial.begin(9600);
    delay(200);
    Wire.begin();

    Serial.println(TITULO);

    OleInit();
    
    pinMode(EBOTON,INPUT_PULLUP);
    pinMode(PIN_IN1,INPUT_PULLUP);
    pinMode(PIN_IN2,INPUT_PULLUP);

  if (clockgen.begin() != ERROR_NONE)  { Serial.println("ERROR, no Si5351"); while(1);}

  Serial.println("Set PLLA to 900MHz");
  clockgen.setupPLLInt(SI5351_PLL_A, 36);
  
  // 900MHZ/(18+1/2)=48.648MHz
  clockgen.setupMultisynth(0, SI5351_PLL_A, Dato1, Dato2, Dato3);
  
  clockgen.enableOutputs(true);
 
  displayPantalla();
}


int tiempo;

void loop(void)
{

  delay(1);
  tiempo++;
  if(tiempo>300)
  {
    tiempo=0;
     if(cambio!=0) { displayfreq();  cambio=0;}
  }
  
  switch(mandoRotary())
    {
      case 1:
        #ifdef DEBUG
          Serial.print(D_encoder);
          Serial.println(" IZQ ");
        #endif
         cambio=1;
             switch(modo)
                {
                  case  0:
                    Dato1--;
                  break;
                  case  1:
                    Dato2--;
                  break;
                  case  2:
                    Dato3--;
                  break;
                }
      break;
      case 2:
        #ifdef DEBUG
        Serial.print(D_encoder);
        Serial.println(" DER ");
        #endif
         cambio=1;
         switch(modo)
                {
                  case  0:
                    Dato1++;
                  break;
                  case  1:
                    Dato2++;
                  break;
                  case  2:
                    Dato3++;
                  break;
                }
      break;
      case 3:
        #ifdef DEBUG
          Serial.println(" BOTON "); 
        #endif
        modo++; if(modo>2) modo=0;
        displayPantalla();
      break;  
    }
  
 
    
}






void displayPantalla()
{
   xclearDisplay(); 
   ModeFont=0; xStringAT(0,0,TITULO);
   displayfreq();
   layout();
}



void displayfreq() 
{
  char buffer[40] = "";

   clockgen.setupMultisynth(0, SI5351_PLL_A, Dato1, Dato2, Dato3);
  
  divisor=(long)Dato1+(float)Dato2/Dato3;
  Serial.print("Divisor=");   Serial.print(divisor); Serial.println(" =D1+(D2/D3)");
  divisor=900000000ULL/divisor;
  
  ModeFont=2; 
  sprintf(buffer,"D1=%03u ",Dato1);  xStringAT(2,1,buffer); Serial.println(buffer);
  sprintf(buffer,"D2=%03u ",Dato2);  xStringAT(2,3,buffer);Serial.println(buffer);
  sprintf(buffer,"D3=%03u ",Dato3);  xStringAT(2,5,buffer);Serial.println(buffer);
 
  unsigned long freq;
  freq=divisor;
  unsigned int m = freq / 1000000;
  unsigned int k = (freq % 1000000) / 1000;
  unsigned int h = (freq % 1000) / 1;

 
  sprintf(buffer,"%03u.%03u.%03u ",m,k,h);
  Serial.print("Frecuencia="); Serial.print(buffer);   Serial.println(" =900M/Divisor");
  Serial.println("---------------");
  ModeFont=0; xStringAT(8,7,buffer);
  
  //sprintf(buffer,"D1=%03u D2=%03u D3=%03u ",Dato1,Dato2,Dato3);
  //Serial.println(buffer);

}

void layout() 
{
  ModeFont=0; xStringAT(3,0,TITULO);

  ModeFont=2; 
  
  switch(modo)
  {
    case  0:
      xStringAT(0,1,"*");
    break;
    case  1:
      xStringAT(0,3,"*");
    break;
    case  2:
      xStringAT(0,5,"*");
    break;
  }
  
}
